<?php
namespace Teknisa\MAN\Factories;

use Doctrine\DBAL\Connection;
use Teknisa\MAN\Utilities\Resposta;

class TransmissaoNFCE {
    
    public function __construct($instanceManager) {
        $this->instanceManager = $instanceManager;
    }
    
    
    const BUSCAR_NOTAS = "WITH FC AS
  (SELECT DISTINCT F.*, FLC.CDCAIXA, FLC.NMCAIXA, FLC.CDLOJA
      FROM V_FILIALLOJACAIXA FLC, (SELECT CDFILIAL, NMFILIAL, CDINSCMUNI, CDINSCESTA, NMRAZSOCFILI, CDINSCESTA AS CDINSCESTA2, NRINSJURFILI
                                     FROM FILIAL
                                    WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:CDFILIAL        = 'T'))) F
     WHERE FLC.CDFILIAL = F.CDFILIAL
      AND ((INSTR(:CDCAIXA, FLC.CDFILIAL||'_'||FLC.CDCAIXA    ) <> 0) OR (:CDCAIXA         = 'T')))

SELECT *  FROM (SELECT
      SUBSTR('Nota Fiscal: ' || V.NRNOTAFISCALCE || ' Caixa: ' || V.CDCAIXA, 1, 33) AS NOTA,
      '      Abrir .txt' AS XMLNOTA, V.NRENVIOSEFAZ, V.DTABERTUR, V.CDOPERADOR, V.IDTPEMISVEND, V.NRORG,
      V.CDFILIAL, V.CDCAIXA, V.CDLOJA, V.NRSEQVENDA, V.DTENTRVENDA, V.NRNOTAFISCALCE, V.DTEMISSAONFCE, V.NRRECIBONFCE, V.NRPROTOCOLONFCE,
      FC.NMFILIAL, V.CDSERIENFCE, V.IDSITUVENDA, V.IDTPAMBNFCE, 'U' AS IDCHECK, V.IDSTATUSNFCE, V.CDEMPRESA, V.IDMODOPERACNFCE,
      FC.NMCAIXA, V.DSOBSSTATUSNFCE, V.NRACESSONFCE, FC.CDINSCMUNI, FC.CDINSCESTA, V.NRLANCTONFCE, P.NRCERTDIGNFCE, V.DTHRPROTOCONFCE,
      V.IDXMLVALIDNFCE, V.NRINSCRCONS, NVL(ARQ.DSARQXMLNFCE, V.DSARQXMLNFCE) AS DSARQXMLNFCE, A.VRTOTALVENDA, S.SGESTADO, S.CDESTADOIBGE , V.DSQRCODENFCE, P.CDVERSAOXMLNFCE, V.DTVENDA,
      CASE WHEN V.IDSITUVENDA = 'C' AND V.IDSTATUSNFCE <> 'C' THEN 'S' ELSE 'N' END AS RED,
      CASE WHEN V.IDSITUVENDA <> 'C' THEN 'S' ELSE 'N' END AS BLACK,
      P.CDCODSCONSPROD, P.CDIDTOKENPROD, P.CDFILIAL AS CDFILIAL2, P.CDCODSCONSHOMO, P.CDIDTOKENHOMO, FC.NMRAZSOCFILI, FC.NRINSJURFILI, FC.CDINSCESTA2,
      P.CDURLWSNFC, V.NRINSJURIEST
    FROM
      VENDA V, PARAVEND P, ENDEFILI E, ESTADO S, FC, ARQXMLNFCESAT ARQ,
      (SELECT
        V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND ,0) + NVL(I.VRACRITVEND,0)) AS VRTOTALVENDA
      FROM
        VENDA V, ITEMVENDA I, FC
      WHERE
        (V.CDFILIAL     = I.CDFILIAL    ) AND
        (V.CDCAIXA      = I.CDCAIXA     ) AND
        (V.NRSEQVENDA   = I.NRSEQVENDA  ) AND        
        (V.CDFILIAL = FC.CDFILIAL) AND
        (V.CDCAIXA = FC.CDCAIXA) AND
        (V.CDLOJA = FC.CDLOJA) AND
        (V.IDSITUVENDA  <> 'D') AND
        (V.IDTPAMBNFCE  = :IDTPAMBNFCE) AND
        (V.IDTPEMISVEND = 'N'           ) AND
        (INSTR(:SITUACAO, V.IDSTATUSNFCE) <> 0) AND
        ((INSTR(:IDMODOPERACNFCE, SUBSTR(V.NRACESSONFCE,35,1)) <> 0) OR (:IDMODOPERACNFCE = 'T')) AND
        ((INSTR(:NRNOTAFISCALCE, V.NRNOTAFISCALCE              ) <> 0) OR (:NRNOTAFISCALCE        = 'T')) AND
        ((INSTR(:IDSITUVENDA, V.IDSITUVENDA        ) <> 0) OR (:IDSITUVENDA     = 'T')) AND
        ((V.NRINSCRCONS IS NOT NULL AND :IDENVIACPF = 'S') OR (V.NRINSCRCONS IS NULL AND :IDENVIACPF = 'N') OR (:IDENVIACPF = 'T')) AND
        (V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN) AND
                      (V.NRACESSONFCE IS NOT NULL)
        GROUP BY V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA) A
    WHERE
      (V.CDFILIAL     = A.CDFILIAL    ) AND
      (V.CDCAIXA      = A.CDCAIXA     ) AND
      (V.NRSEQVENDA   = A.NRSEQVENDA  ) AND
      (V.CDFILIAL     = ARQ.CDFILIAL (+)    ) AND
      (V.CDCAIXA      = ARQ.CDCAIXA  (+)   ) AND
      (V.NRSEQVENDA   = ARQ.NRSEQVENDA (+) ) AND
      (V.CDFILIAL     = P.CDFILIAL    ) AND
      ((P.DTVALCERTDIGNFCE IS NOT NULL AND P.DTVALCERTDIGNFCE >= SYSDATE) OR (:TPCERTIFICADO     = 'T')) AND
      (E.CDFILIAL     = FC.CDFILIAL    ) AND
      (E.IDTPENDEFILI = 'P'           ) AND
      (S.CDPAIS       = E.CDPAIS      ) AND
      (S.SGESTADO     = E.SGESTADO    ) AND
      (V.CDFILIAL = FC.CDFILIAL) AND
      (V.CDCAIXA = FC.CDCAIXA) AND
      (V.CDLOJA = FC.CDLOJA)

    ORDER BY
      V.DTENTRVENDA, V.CDFILIAL, V.CDCAIXA, V.NRNOTAFISCALCE)
      WHERE (CDFILIAL||CDCAIXA||DTENTRVENDA||NRNOTAFISCALCE||CDSERIENFCE||VRTOTALVENDA||IDSITUVENDA||NRINSCRCONS||NRACESSONFCE like :ALLFIEDLS  OR :ALLFIEDLS = 'T' )";
      
      
    const UPDATENRINSCRCONS  = "
        UPDATE VENDA
          SET NRINSCRCONS     = :NRINSCRCONS
         WHERE (CDFILIAL       = :CDFILIAL      ) AND
              (CDCAIXA        = :CDCAIXA       ) AND
              (NRSEQVENDA     = :NRSEQVENDA    ) AND
              (NRNOTAFISCALCE = :NRNOTAFISCALCE)";
              
    const UPDATENRENVIOSEFAZ  = "
        UPDATE VENDA 
            SET
            NRENVIOSEFAZ = 1,
            IDCONSUINDEVIDO = 'N'
        WHERE (CDFILIAL = :CDFILIAL)
            AND (CDCAIXA = :CDCAIXA)
            AND (NRSEQVENDA = :NRSEQVENDA)
            AND (NRORG = :NRORG)";
            
            
    const GET_LINK_CERTIFICADO = "
        SELECT P.FILESERVERURL || 
		       SUBSTR(I.DSDIRCERTIFICADO, INSTR(I.DSDIRCERTIFICADO, '>')+1) DSDIRCERTIFICADO, I.CDSENHACERTIF, I.DSDIRCERTIFICADO CERTIFICADO, 
		       (SELECT DSSENHACERTNFCE FROM PARAVEND WHERE CDFILIAL = :CDFILIAL) AS DSSENHACERTNFCE
		  FROM INSCRESTAD I, PARAMGERAL P
		 WHERE I.CDINSCESTA = :CDINSCESTA";
		 
    const GET_LINK_CERTIFICADO_UNID = "SELECT DSDIRCERTIFICADO, DSDIRCERTIFICADO AS CERTIFICADO, DSSENHACERTNFCE FROM  PARAVEND WHERE CDFILIAL = :CDFILIAL";
    
    const UPDATE_VENDA_STATUS_NFCE_CAN_SB = "
	   UPDATE VENDA
          SET DSOBSSTATUSNFCE = :DSOBSSTATUSNFCE, NRPROTOCOLOCANC = :NRPROTOCOLOCANC, IDSTATUSNFCE = :IDSTATUSNFCE,
            DTHRPROTOCOCANC = :DTHRPROTOCOCANC, DSRAZAOCANCNFCE = :DSRAZAOCANCNFCE,
            DSARQXMLCANCNFCE = :DSARQXMLCANCNFCE, CDOPERADORCANC = :CDOPERADORCANC
        WHERE CDFILIAL = :CDFILIAL
          AND CDCAIXA = :CDCAIXA
          AND NRSEQVENDA = :NRSEQVENDA";
          
    const UPDATE_ARQXMLNFCESAT_STATUS_NFCE_CAN_SB = "
	   UPDATE ARQXMLNFCESAT
          SET DSARQXMLCANCNFCE = :DSARQXMLCANCNFCE
        WHERE CDFILIAL = :CDFILIAL
          AND CDCAIXA = :CDCAIXA
          AND NRSEQVENDA = :NRSEQVENDA";
          
    const INSERT_ARQXMLNFCESAT_STATUS_NFCE_CAN_SB = "
	   INSERT INTO ARQXMLNFCESAT ( CDFILIAL, CDCAIXA, NRSEQVENDA, DSARQXMLCANCNFCE) 
	    VALUES (:CDFILIAL, :CDCAIXA, :NRSEQVENDA, :DSARQXMLCANCNFCE)";
          
    const SELECT_VENDA_ARQXMLNFCESAT = "
	   SELECT COUNT(*) AS VEND FROM ARQXMLNFCESAT
        WHERE CDFILIAL = :CDFILIAL
          AND CDCAIXA = :CDCAIXA
          AND NRSEQVENDA = :NRSEQVENDA";
          
    const ADQPARAVEND = "
        SELECT IDCANCEXTNFCE, IDGERALOGNFCE, DSDIRARQLOGNFCE, SYSDATE AS DTATUAL,
              IDCANCAUTNFCE, DSJUSTCANCNFCE, CDVERSAOXMLNFCE
          FROM PARAVEND
         WHERE CDFILIAL = :CDFILIAL";    
         
    const ACMCANCELAVENDA = "
	   UPDATE VENDA
			SET TXOBSVENDA = :MENSAGEM,
				IDCANCMANUAL = 'S'
		WHERE CDFILIAL = :CDFILIAL 
			AND CDCAIXA = :CDCAIXA 
			AND NRSEQVENDA = :NRSEQVENDA";
			
		const ACMCANCELAMOVCAIXA = "
	   UPDATE MOVCAIXA
			SET IDTIPOMOVIVE = 'C'
		WHERE CDFILIAL = :CDFILIAL 
			AND CDCAIXA = :CDCAIXA 
			AND NRSEQVENDA = :NRSEQVENDA";
			
		const ACMUPDULTMOVICLIE = "
	   UPDATE MOVICLIE
			SET IDTIPMOCVLI = 'X'
		WHERE (CDFILIAL = :CDFILIAL) 
			AND (CDCAIXA = :CDCAIXA) 
			AND (NRSEQVENDA = :NRSEQVENDA)";
			
		const ADQMOVICLIE = "
	   SELECT VE.CDFILIAL, M.CDCLIENTE, M.CDCONSUMIDOR, VE.CDOPERADOR, VE.CDCAIXA, VE.NRSEQVENDA, M.VRMOVCLI, M.VRSALDOCONS, M.NRSEQMOVCLI
		FROM MOVICLIE M, VENDA VE
		WHERE (M.CDFILIAL = :CDFILIAL )
			AND (M.CDCAIXA = :CDCAIXA )
			AND (M.NRSEQVENDA = :NRSEQVENDA )
			AND (M.CDFILIAL = VE.CDFILIAL )
			AND (M.CDCAIXA = VE.CDCAIXA )
			AND (M.NRSEQVENDA = VE.NRSEQVENDA )
			AND (M.CDCLIENTE = VE.CDCLIENTE )";
			
		const ACMUPDSALDOMOVICLIE = "
	   UPDATE MOVICLIE
			SET VRSALDOCONS = :VRSALDOCONS
		WHERE (CDCLIENTE = :CDCLIENTE ) 
			AND (CDCONSUMIDOR = :CDCONSUMIDOR) 
			AND (NRSEQMOVCLI = :NRSEQMOVCLI ) 
			AND (NRSEQVENDA = :NRSEQVENDA )";
			
		const ADQNUMERACAO = "
       SELECT *  FROM ( SELECT I.CDFILIAL, I.CDCAIXA, I.NRNOTAFISCALCE, I.CDSERIENFCE, I.IDTPAMBNFCE,
          F.CDEMPRESA, F.CDINSCESTA, F.CDINSCMUNI, P.NRCERTDIGNFCE, I.IDSTATUSNFCE,
          I.DSOBSINUTNFCE, P.CDVERSAOXMLNFCE, I.CDFILIAL||'_'||I.CDCAIXA||'_'||I.NRNOTAFISCALCE AS CODNOTA, I.NRINSJURFILI
        FROM
          INUTILIZANFCE I, FILIAL F, PARAVEND P
        WHERE
          (I.CDFILIAL    = :CDFILIAL   ) AND
          ((INSTR(:CDCAIXA, I.CDFILIAL||I.CDCAIXA) <> 0) OR (:CDCAIXA = 'T')) AND
          (I.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN) AND
          ((INSTR(:NRNOTAFISCALCE, I.NRNOTAFISCALCE) <> 0) OR (:NRNOTAFISCALCE = 'T')) AND
          (I.CDFILIAL    = F.CDFILIAL    ) AND
          (I.CDFILIAL    = P.CDFILIAL    ) AND
          (NOT EXISTS (SELECT 1 FROM VENDA V
                         WHERE I.CDFILIAL       = V.CDFILIAL
                          AND I.NRNOTAFISCALCE = V.NRNOTAFISCALCE
                          AND I.CDSERIENFCE    = V.CDSERIENFCE
                          AND I.DTENTRVENDA    = V.DTENTRVENDA))
        ORDER BY
          I.CDCAIXA, I.NRNOTAFISCALCE)
      WHERE (CDCAIXA||NRNOTAFISCALCE||DSOBSINUTNFCE like :ALLFIEDLS  OR :ALLFIEDLS = 'T' )";
          
    const ADQNUMERACAO_FULL = "
        SELECT I.CDFILIAL, I.CDCAIXA, I.NRNOTAFISCALCE, I.CDSERIENFCE, I.IDTPAMBNFCE, '0' NRENVIOSEFAZ,
          F.CDEMPRESA, F.CDINSCESTA, F.CDINSCMUNI, P.NRCERTDIGNFCE, I.IDSTATUSNFCE,
          I.DSOBSINUTNFCE, P.CDVERSAOXMLNFCE, P.IDAMBTRABNFCE, P.CDCODSCONSPROD, P.CDURLWSNFC,
          P.CDIDTOKENPROD, P.CDCODSCONSHOMO, P.CDIDTOKENHOMO, F.NMRAZSOCFILI, F.NRINSJURFILI AS NRINSJURIEST, IE.SGESTADO
        FROM
          INUTILIZANFCE I, FILIAL F, PARAVEND P, INSCRESTAD IE
        WHERE
          (I.CDFILIAL    = :CDFILIAL   ) AND
          (I.CDCAIXA     = :CDCAIXA   ) AND
          (I.NRNOTAFISCALCE = :NRNOTAFISCALCE   ) AND
          (I.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN) AND
          (I.CDFILIAL    = F.CDFILIAL     ) AND
          (I.CDFILIAL    = P.CDFILIAL     ) AND
          (IE.CDINSCESTA = F.CDINSCESTA   ) AND
          (IE.CDEMPRESA  = F.CDEMPRESA    ) AND
          (NOT EXISTS (SELECT 1 FROM VENDA V
                         WHERE I.CDFILIAL       = V.CDFILIAL
                          AND I.NRNOTAFISCALCE = V.NRNOTAFISCALCE
                          AND I.CDSERIENFCE    = V.CDSERIENFCE
                          AND I.DTENTRVENDA    = V.DTENTRVENDA))
        ORDER BY
          I.CDCAIXA, I.NRNOTAFISCALCE";
          
    const ACMUPDINUTILIZANFCE = "
        UPDATE INUTILIZANFCE
          SET IDSTATUSNFCE    = :IDSTATUSNFCE,
              DTHRINUTNFCE    = :DTHRINUTNFCE,
              NRPROTOINUTNFCE = :NRPROTOINUTNFCE,
              IDTPEMISINUNFCE = :IDTPEMISINUNFCE,
              DSRAZAOINUTNFCE = :DSRAZAOINUTNFCE,
              DSOBSINUTNFCE   = :DSOBSINUTNFCE,
              NRINSJURFILI   = :NRINSJURFILI
         WHERE (CDFILIAL       = :CDFILIAL      ) AND
              (CDCAIXA        = :CDCAIXA       ) AND
              (NRNOTAFISCALCE = :NRNOTAFISCALCE)";   
               
    const ACMUPDINUTILIZA = "
        UPDATE INUTILIZANFCE
          SET IDSTATUSNFCE    = :IDSTATUSNFCE,
              IDTPEMISINUNFCE = :IDTPEMISINUNFCE,
              DSRAZAOINUTNFCE = :DSRAZAOINUTNFCE,
              DSOBSINUTNFCE   = :DSOBSINUTNFCE,
              NRINSJURFILI   = :NRINSJURFILI
         WHERE (CDFILIAL       = :CDFILIAL      ) AND
              (CDCAIXA        = :CDCAIXA       ) AND
              (NRNOTAFISCALCE = :NRNOTAFISCALCE)";
              
    const SELECT_STATUS_VENDA = "
	   SELECT V.IDSTATUSNFCE, V.NRENVIOSEFAZ, NVL(ARQ.DSARQXMLNFCE, V.DSARQXMLNFCE) AS DSARQXMLNFCE FROM VENDA V, ARQXMLNFCESAT ARQ
        WHERE V.CDFILIAL = :CDFILIAL
          AND V.CDCAIXA = :CDCAIXA
          AND V.NRSEQVENDA = :NRSEQVENDA
          AND (V.CDFILIAL     = ARQ.CDFILIAL (+)    ) 
          AND (V.CDCAIXA      = ARQ.CDCAIXA  (+)   ) 
          AND (V.NRSEQVENDA   = ARQ.NRSEQVENDA (+) )";
          
    const ACMUPDPROTOCNFCE = " 
        UPDATE VENDA
          SET IDSTATUSNFCE    = :IDSTATUSNFCE,
              DSOBSSTATUSNFCE = :DSOBSSTATUSNFCE,
              NRPROTOCOLONFCE = :NRPROTOCOLONFCE,
              DTHRPROTOCONFCE = :DTHRPROTOCONFCE,
              NRACESSONFCE    = :NRACESSONFCE,
              NRENVIOSEFAZ    = NVL(NRENVIOSEFAZ,1)+1
         WHERE (CDFILIAL   = :CDFILIAL  ) AND
              (CDCAIXA    = :CDCAIXA   ) AND
              (NRSEQVENDA = :NRSEQVENDA)";  
              
    const UPDATE_VENDA_NFCE = "
        UPDATE VENDA
          SET DTULTATU = SYSDATE, DSQRCODENFCE = :DSQRCODENFCE
        WHERE NRSEQVENDA = :NRSEQVENDA
            AND CDFILIAL = :CDFILIAL
            AND CDCAIXA = :CDCAIXA";  
          
    const UPDATE_ARQXMLNFCESAT_XML = "
	   UPDATE ARQXMLNFCESAT
          SET DSARQXMLNFCE = :DSARQXMLNFCE
        WHERE CDFILIAL = :CDFILIAL
          AND CDCAIXA = :CDCAIXA
          AND NRSEQVENDA = :NRSEQVENDA";
          
    const INSERT_ARQXMLNFCESAT_XML = "
	   INSERT INTO ARQXMLNFCESAT ( CDFILIAL, CDCAIXA, NRSEQVENDA, DSARQXMLNFCE) 
	    VALUES (:CDFILIAL, :CDCAIXA, :NRSEQVENDA, :DSARQXMLNFCE)";
	    
	    
	 const ADQTRANSMISSAONFCE = "SELECT * FROM (SELECT
  FI.CDFILIAL, FI.NMFILIAL, FI.NMRAZSOCFILI, FI.NRINSJURFILI, FI.CDINSCMUNI, FI.CDINSCESTA,
  FI.IDCUMUPISCOFIL, CX.CDCAIXA, CX.NMCAIXA, CX.CDLOJA,
  LJ.IDCOMISVENDA, LJ.VRCOMISVENDA, LJ.IDIMPCNPJCLIE,
  IE.SGESTADO, IE.DSENDEIEST, IE.NMBAIRIEST, IE.NRCEPIEST,
  EM.CDCNAE, PE.CDSITUCRT, PV.IDAMBTRABNFCE, PV.NRCERTDIGNFCE, PV.CDURLWSNFC, PV.CDIDTOKENPROD,
  PV.CDIDTOKENHOMO, PV.CDCODSCONSPROD, PV.CDCODSCONSHOMO, PV.CDVERSAOXMLNFCE, PV.CDVERSAOQRCNFCE,
  ES.CDESTADOIBGE, ES.HRDIFUTCFUSO, MN.CDMUNICIBGE, MN.NMMUNICIPIO,
  VE. NRSEQVENDA, TO_CHAR(VE.DTEMISSAONFCE, 'YYYY-MM-DD HH:MM:SS') AS DTEMISSAONFCE, VE.NRNOTAFISCALCE, VE.NRLANCTONFCE, VE.NRACESSONFCE,
  VE.IDTPAMBNFCE, VE.CDSERIENFCE, VE.IDORIGEMVENDA, VE.VRDESCVENDA, VE.IDSTATUSNFCE, VE.IDSITUVENDA,
  VE.CDCLIENTE, VE.CDCONSUMIDOR, VE.DSENDECONSVENDA,
  SUM(IT.QTPRODVEND) AS QTPRODVEND,

  (IT.VRUNITVEND+IT.VRUNITVENDCL +  SUM(NVL((case
                                            when (LJ.CDPRODTAXASERV = PR.CDPRODUTO) or
                                            (LJ.CDPRODTAXAENTR = PR.CDPRODUTO) or
                                            (LJ.CDPRODTXEXCEDE = PR.CDPRODUTO) then IT.VRACRITVEND 
                                            else 0 end), 0))) AS VRUNITVEND,
  SUM(NVL((case
                when (LJ.CDPRODTAXASERV = PR.CDPRODUTO) or
                (LJ.CDPRODTAXAENTR = PR.CDPRODUTO) or
                (LJ.CDPRODTXEXCEDE = PR.CDPRODUTO) then 0
                else IT.VRACRITVEND
                end), 0)) AS VRACRITVEND,

  SUM(NVL(IT.VRDESITVEND,0)) AS VRDESITVEND,
  PR.CDPRODUTO, PR.SGUNIDADE, PR.NMPRODUTO, PR.CDBARPRODUTO, PR.CDCLASFISC,
  (NVL(
  CASE PV.IDENVIACDBARXML
  WHEN 'S' THEN PR.CDBARPRODUTO
  WHEN 'X' THEN PR.CDPRODUTOEXT
  ELSE PR.CDARVPROD END
  ,PR.CDARVPROD)) AS CDARVPROD,
  AL.VRPEALIMPFIS, AL.IDTPIMPOSFIS, AL.VRALIQIBPT, AL.VRALIQIBPTES, AL.CDCFOPPFIS,
  AL.CDCSTICMS, AL.CDCSTPISCOF, AL.VRALIQPIS, AL.VRALIQCOFINS, AL.VRPERCREDUCAO,
  NVL(AL.CDCEST,PR.CDCEST) AS CDCEST, AL.VRPEALIMPFISEF, AL.VRPERCREDUCAOEF,
  IP.VRTOTTRIBIBPT, '' AS NRSEQUITVEND, AL.CDCBENEF, IP.VRBASECALCICMS, IP.VRBCPISCOFINS,
  IP.VRBASECALCREDUZ,
  ROUND_ABNT(SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * AL.VRPEALIMPFIS / 100, 2) AS VRIMPOPRODIT,
  SUM(NVL(IP.VRIMPOPRODREDUZ,0)) AS VRIMPOPRODREDUZ,
  IP.VRIMPPIS, IP.VRIMPCOFINS, IP.VRIMPICMSFCP, AL.VRALIQFCP,
  PV.IDRESPTECNFCE, IP.VRPEALEFPRODIT, IP.VRIMPOEFPRODIT, IP.VRBCREDUZEFICMS, IP.VRPRBCREDUEFICMS,
  AL.VRALIQICMSDES, TRIM(REPLACE(REPLACE(CX.DSOBSCUPFIS,CHR(10),''),CHR(13),'')) AS DSOBSCUPFIS , FI.NRORG, PA.CDPAISBACEN, PA.NMPAIS, IE.CDPAIS,
  EM.CDEMPRESA, MN.CDMUNICIPIO, PV.NMARQCERTNFCE, PV.DSSENHACERTNFCE, IP.CDCSTPRODI, IP.VRPEALPRODIT, IP.VRPERPIS, PV.IDNOTATECNFCE
FROM
  VENDA VE, FILIAL FI, CAIXA CX, LOJA LJ, INSCRESTAD IE, EMPRESA EM, PARAMEMPRESA PE,
  PARAVEND PV, ESTADO ES, MUNICIPIO MN, ITEMVENDA IT,
  (select DISTINCT PX.CDPRODUTOEXT, PR.* FROM PRODUTO PR LEFT JOIN PRODEXTERNO PX ON PX.CDPRODUTO=PR.CDPRODUTO AND  PX.CDFILIAL = :CDFILIAL) PR,
    ALIQIMPFIS AL, ITVENDAIMPOS IP, PAIS PA
WHERE
  (FI.CDFILIAL      = :CDFILIAL    ) AND
  (CX.CDCAIXA       = :CDCAIXA     ) AND
  (LJ.CDLOJA        = :CDLOJA      ) AND
  (FI.CDFILIAL      = CX.CDFILIAL    ) AND
  (FI.CDFILIAL      = LJ.CDFILIAL    ) AND
  (FI.CDEMPRESA     = EM.CDEMPRESA   ) AND
  (FI.CDEMPRESA     = PE.CDEMPRESA   ) AND
  (FI.CDFILIAL      = PV.CDFILIAL    ) AND
  (IE.CDINSCESTA    = FI.CDINSCESTA  ) AND
  (IE.CDEMPRESA     = FI.CDEMPRESA   ) AND
  (IE.CDPAIS        = ES.CDPAIS      ) AND
  (IE.SGESTADO      = ES.SGESTADO    ) AND
  (IE.CDPAIS        = PA.CDPAIS      ) AND
  (IE.CDPAIS        = MN.CDPAIS      ) AND
  (IE.SGESTADO      = MN.SGESTADO    ) AND
  (IE.CDMUNICIPIO   = MN.CDMUNICIPIO ) AND
  (FI.CDFILIAL      = VE.CDFILIAL    ) AND
  (CX.CDCAIXA       = VE.CDCAIXA     ) AND
  (VE.NRSEQVENDA    = :NRSEQVENDA  ) AND
  (VE.NRSEQVENDA    = IT.NRSEQVENDA  ) AND
  (VE.CDFILIAL      = IT.CDFILIAL    ) AND
  (VE.CDCAIXA       = IT.CDCAIXA     ) AND
  (IT.CDPRODUTO     = PR.CDPRODUTO   ) AND
  (AL.CDPRODUTO     = PR.CDPRODUTO   ) AND
  (FI.CDFILIAL      = AL.CDFILIAL    ) AND
  (IP.CDFILIAL      = VE.CDFILIAL    ) AND
  (IP.CDCAIXA       = VE.CDCAIXA     ) AND
  (IP.NRSEQUITVEND  = IT.NRSEQUITVEND) AND
  (IP.NRSEQVENDA    = VE.NRSEQVENDA  ) AND
  (VE.IDSTATUSNFCE  <> 'T'           ) AND
  (VE.NRACESSONFCE IS NOT NULL       ) AND
  (PV.IDAGRUPITEMXML = 'S'           ) AND
  ('I' = (CASE IT.QTPRODVEND-TRUNC(IT.QTPRODVEND) WHEN 0 THEN 'I' ELSE 'D' END))
GROUP BY
  FI.CDFILIAL, FI.NMFILIAL, FI.NMRAZSOCFILI, FI.NRINSJURFILI, FI.CDINSCMUNI, FI.CDINSCESTA, FI.IDCUMUPISCOFIL,
  CX.CDCAIXA, CX.NMCAIXA, CX.CDLOJA,
  LJ.IDCOMISVENDA, LJ.VRCOMISVENDA, LJ.IDIMPCNPJCLIE,
  IE.SGESTADO, IE.DSENDEIEST, IE.NMBAIRIEST, IE.NRCEPIEST,
  EM.CDCNAE,
  PE.CDSITUCRT,
  PV.IDAMBTRABNFCE, PV.NRCERTDIGNFCE, PV.CDURLWSNFC, PV.CDIDTOKENPROD, PV.CDIDTOKENHOMO, PV.CDCODSCONSPROD, PV.CDCODSCONSHOMO,  PV.CDVERSAOXMLNFCE, PV.CDVERSAOQRCNFCE,
  ES.CDESTADOIBGE, ES.HRDIFUTCFUSO,
  MN.CDMUNICIBGE, MN.NMMUNICIPIO,
  VE. NRSEQVENDA, VE.DTEMISSAONFCE, VE.NRNOTAFISCALCE, VE.NRLANCTONFCE, VE.NRACESSONFCE, VE.IDTPAMBNFCE,
  VE.CDSERIENFCE, VE.IDORIGEMVENDA, VE.VRDESCVENDA, VE.IDSTATUSNFCE, VE.IDSITUVENDA,
  VE.CDCLIENTE, VE.CDCONSUMIDOR, VE.DSENDECONSVENDA,
  (IT.VRUNITVEND+IT.VRUNITVENDCL), PR.CDPRODUTO, PR.SGUNIDADE, PR.NMPRODUTO, PR.CDBARPRODUTO, PR.CDCLASFISC,
  (NVL(
  CASE PV.IDENVIACDBARXML
  WHEN 'S' THEN PR.CDBARPRODUTO
  WHEN 'X' THEN PR.CDPRODUTOEXT
  ELSE PR.CDARVPROD END
  ,PR.CDARVPROD)),
  AL.VRPEALIMPFIS, AL.IDTPIMPOSFIS, AL.VRALIQIBPT, AL.VRALIQIBPTES, AL.CDCFOPPFIS, AL.CDCSTICMS, AL.CDCSTPISCOF,
  AL.VRALIQPIS, AL.VRALIQCOFINS, AL.VRPERCREDUCAO, NVL(AL.CDCEST,PR.CDCEST), AL.VRPEALIMPFISEF, AL.VRPERCREDUCAOEF,
  IP.VRTOTTRIBIBPT, AL.CDCBENEF, IP.VRBASECALCICMS, IP.VRBCPISCOFINS, IP.VRBASECALCREDUZ,
  IP.VRIMPPIS, IP.VRIMPCOFINS, IP.VRIMPICMSFCP, AL.VRALIQFCP, PV.IDRESPTECNFCE,
  IP.VRPEALEFPRODIT, IP.VRIMPOEFPRODIT, IP.VRBCREDUZEFICMS, IP.VRPRBCREDUEFICMS,
  AL.VRALIQICMSDES, CX.DSOBSCUPFIS, FI.NRORG, PA.CDPAISBACEN, PA.NMPAIS, IE.CDPAIS,EM.CDEMPRESA, MN.CDMUNICIPIO,
  PV.NMARQCERTNFCE, PV.DSSENHACERTNFCE, IP.CDCSTPRODI, IP.VRPEALPRODIT, IP.VRPERPIS, PV.IDNOTATECNFCE

UNION

SELECT
  FI.CDFILIAL, FI.NMFILIAL, FI.NMRAZSOCFILI, FI.NRINSJURFILI, FI.CDINSCMUNI, FI.CDINSCESTA,
  FI.IDCUMUPISCOFIL, CX.CDCAIXA, CX.NMCAIXA, CX.CDLOJA,
  LJ.IDCOMISVENDA, LJ.VRCOMISVENDA, LJ.IDIMPCNPJCLIE,
  IE.SGESTADO, IE.DSENDEIEST, IE.NMBAIRIEST, IE.NRCEPIEST, EM.CDCNAE, PE.CDSITUCRT,
  PV.IDAMBTRABNFCE, PV.NRCERTDIGNFCE, PV.CDURLWSNFC, PV.CDIDTOKENPROD, PV.CDIDTOKENHOMO,
  PV.CDCODSCONSPROD, PV.CDCODSCONSHOMO, PV.CDVERSAOXMLNFCE, PV.CDVERSAOQRCNFCE,
  ES.CDESTADOIBGE, ES.HRDIFUTCFUSO, MN.CDMUNICIBGE, MN.NMMUNICIPIO,
  VE. NRSEQVENDA, TO_CHAR(VE.DTEMISSAONFCE, 'YYYY-MM-DD HH:MM:SS') AS DTEMISSAONFCE, VE.NRNOTAFISCALCE, VE.NRLANCTONFCE,
  VE.NRACESSONFCE, VE.IDTPAMBNFCE,
  VE.CDSERIENFCE, VE.IDORIGEMVENDA, VE.VRDESCVENDA, VE.IDSTATUSNFCE, VE.IDSITUVENDA,
  VE.CDCLIENTE, VE.CDCONSUMIDOR, VE.DSENDECONSVENDA,
  IT.QTPRODVEND,

  (IT.VRUNITVEND+IT.VRUNITVENDCL + NVL((case
                                            when (LJ.CDPRODTAXASERV = PR.CDPRODUTO) or
                                            (LJ.CDPRODTAXAENTR = PR.CDPRODUTO) or
                                            (LJ.CDPRODTXEXCEDE = PR.CDPRODUTO) then IT.VRACRITVEND 
                                            else 0 end), 0)) AS VRUNITVEND,
  NVL((case
                when (LJ.CDPRODTAXASERV = PR.CDPRODUTO) or
                (LJ.CDPRODTAXAENTR = PR.CDPRODUTO) or
                (LJ.CDPRODTXEXCEDE = PR.CDPRODUTO) then 0
                else IT.VRACRITVEND
                end), 0) AS VRACRITVEND,

  NVL(IT.VRDESITVEND,0) AS VRDESITVEND,
  PR.CDPRODUTO, PR.SGUNIDADE, PR.NMPRODUTO, PR.CDBARPRODUTO, PR.CDCLASFISC,
  (NVL(
  CASE PV.IDENVIACDBARXML
  WHEN 'S' THEN PR.CDBARPRODUTO
  WHEN 'X' THEN PR.CDPRODUTOEXT
  ELSE PR.CDARVPROD END
  ,PR.CDARVPROD)) AS CDARVPROD,
  AL.VRPEALIMPFIS, AL.IDTPIMPOSFIS, AL.VRALIQIBPT, AL.VRALIQIBPTES, AL.CDCFOPPFIS,
  AL.CDCSTICMS, AL.CDCSTPISCOF, AL.VRALIQPIS, AL.VRALIQCOFINS, AL.VRPERCREDUCAO,
  NVL(AL.CDCEST,PR.CDCEST) AS CDCEST, AL.VRPEALIMPFISEF, AL.VRPERCREDUCAOEF,
  IP.VRTOTTRIBIBPT, IT.NRSEQUITVEND, AL.CDCBENEF, IP.VRBASECALCICMS, IP.VRBCPISCOFINS,
  IP.VRBASECALCREDUZ, IP.VRIMPOPRODIT, IP.VRIMPOPRODREDUZ,
  IP.VRIMPPIS,IP.VRIMPCOFINS, IP.VRIMPICMSFCP, AL.VRALIQFCP,
  PV.IDRESPTECNFCE, IP.VRPEALEFPRODIT, IP.VRIMPOEFPRODIT, IP.VRBCREDUZEFICMS, IP.VRPRBCREDUEFICMS,
  AL.VRALIQICMSDES, TRIM(REPLACE(REPLACE(CX.DSOBSCUPFIS,CHR(10),''),CHR(13),'')) AS DSOBSCUPFIS, FI.NRORG, PA.CDPAISBACEN, PA.NMPAIS, IE.CDPAIS, EM.CDEMPRESA, MN.CDMUNICIPIO,
  PV.NMARQCERTNFCE, PV.DSSENHACERTNFCE, IP.CDCSTPRODI, IP.VRPEALPRODIT, IP.VRPERPIS, PV.IDNOTATECNFCE
FROM
  VENDA VE, FILIAL FI, CAIXA CX, LOJA LJ, INSCRESTAD IE, EMPRESA EM, PARAMEMPRESA PE, PARAVEND PV, ESTADO ES,
  MUNICIPIO MN, ITEMVENDA IT,
  (select DISTINCT PX.CDPRODUTOEXT, PR.* FROM PRODUTO PR LEFT JOIN PRODEXTERNO PX ON PX.CDPRODUTO=PR.CDPRODUTO AND  PX.CDFILIAL = :CDFILIAL) PR,
  ALIQIMPFIS AL, ITVENDAIMPOS IP, PAIS PA
WHERE
  (FI.CDFILIAL      = :CDFILIAL    ) AND
  (CX.CDCAIXA       = :CDCAIXA     ) AND
  (LJ.CDLOJA        = :CDLOJA      ) AND
  (FI.CDFILIAL      = CX.CDFILIAL    ) AND
  (FI.CDFILIAL      = LJ.CDFILIAL    ) AND
  (FI.CDEMPRESA     = EM.CDEMPRESA   ) AND
  (FI.CDEMPRESA     = PE.CDEMPRESA   ) AND
  (FI.CDFILIAL      = PV.CDFILIAL    ) AND
  (IE.CDINSCESTA    = FI.CDINSCESTA  ) AND
  (IE.CDEMPRESA     = FI.CDEMPRESA   ) AND
  (IE.CDPAIS        = ES.CDPAIS      ) AND
  (IE.SGESTADO      = ES.SGESTADO    ) AND
  (IE.CDPAIS        = PA.CDPAIS      ) AND
  (IE.CDPAIS        = MN.CDPAIS      ) AND
  (IE.SGESTADO      = MN.SGESTADO    ) AND
  (IE.CDMUNICIPIO   = MN.CDMUNICIPIO ) AND
  (FI.CDFILIAL      = VE.CDFILIAL    ) AND
  (CX.CDCAIXA       = VE.CDCAIXA     ) AND
  (VE.NRSEQVENDA    = :NRSEQVENDA  ) AND
  (VE.NRSEQVENDA    = IT.NRSEQVENDA  ) AND
  (VE.CDFILIAL      = IT.CDFILIAL    ) AND
  (VE.CDCAIXA       = IT.CDCAIXA     ) AND
  (IT.CDPRODUTO     = PR.CDPRODUTO   ) AND
  (AL.CDPRODUTO     = PR.CDPRODUTO   ) AND
  (FI.CDFILIAL      = AL.CDFILIAL    ) AND
  (IP.CDFILIAL      = VE.CDFILIAL    ) AND
  (IP.CDCAIXA       = VE.CDCAIXA     ) AND
  (IP.NRSEQUITVEND  = IT.NRSEQUITVEND) AND
  (IP.NRSEQVENDA    = VE.NRSEQVENDA  ) AND
  (VE.IDSTATUSNFCE  <> 'T'           ) AND
  (VE.NRACESSONFCE IS NOT NULL       ) AND
  (('D' = (CASE IT.QTPRODVEND-TRUNC(IT.QTPRODVEND) WHEN 0 THEN 'I' ELSE 'D' END)) OR (PV.IDAGRUPITEMXML = 'N')))
  ORDER BY CDPRODUTO DESC";
  
  
  const GET_CONSUMER_SALE = "
          SELECT
            VE.CDFILIAL, VE.CDCAIXA, VE.NRSEQVENDA, VE.DTENTRVENDA, VE.NRNOTAFISCALCE,
            VE.NRACESSONFCE, VE.NRINSCRCONS, VE.NMCONSVEND, VE.CDCLIENTE, VE.CDCONSUMIDOR,
            CO.NMCONSUMIDOR, CO.NRCPFRESPCON, CL.IDTPIJURCLIE, CL.NRINSJURCLIE, CO.VRMAXDEBCONS,
            CO.VRMAXCREDCONS, CO.VRMESUBCONS, CL.NMFANTCLIE, VE.DSENDECONSVENDA, IE.NMBAIRIEST,
            MN.CDMUNICIBGE, MN.NMMUNICIPIO, ES.CDESTADOIBGE, ES.SGESTADO
          FROM
            VENDA VE JOIN FILIAL FI
                      ON VE.CDFILIAL = FI.CDFILIAL
            LEFT JOIN INSCRESTAD IE
                      ON FI.CDINSCESTA = IE.CDINSCESTA
                    AND FI.CDEMPRESA = IE.CDEMPRESA
            LEFT JOIN ESTADO ES
                    ON IE.CDPAIS = ES.CDPAIS
                    AND IE.SGESTADO = ES.SGESTADO
            LEFT JOIN MUNICIPIO MN
                      ON IE.CDPAIS = MN.CDPAIS
                      AND IE.SGESTADO = MN.SGESTADO
                      AND IE.CDMUNICIPIO = MN.CDMUNICIPIO
            LEFT JOIN CLIENTE CL
                      ON VE.CDCLIENTE = CL.CDCLIENTE
            LEFT JOIN CONSUMIDOR CO
                      ON VE.CDCLIENTE = CO.CDCLIENTE
                    AND VE.CDCONSUMIDOR = CO.CDCONSUMIDOR
          WHERE
            (VE.CDFILIAL   = :CDFILIAL  ) AND
            (VE.CDCAIXA    = :CDCAIXA   ) AND
            (VE.NRSEQVENDA = :NRSEQVENDA)";
            
    const GET_PAYMENTS = "
		SELECT TR.NMTIPORECE, MC.VRMOVIVEND, TR.IDTIPORECE, MC.IDTIPOMOVIVE, TR.CDBANCARTCR, TR.CDADMINCART,
            MC.CDNSUHOSTTEF, MC.QTPARCRECEB, TR.CDBANCARTSEFAZ, TR.IDDESABTEF
          FROM TIPORECE TR, MOVCAIXA MC
        WHERE MC.CDFILIAL     = :CDFILIAL
            AND MC.CDCAIXA    = :CDCAIXA
            AND MC.NRSEQVENDA = :NRSEQVENDA
            AND TR.CDTIPORECE = MC.CDTIPORECE";
            
            
    const UPDATE_VENDA_NFCE_XML = "
        UPDATE VENDA
          SET 
            NRACESSONFCE = :NRACESSONFCE,
            IDSTATUSNFCE = :IDSTATUSNFCE,
            NRPROTOCOLONFCE = :NRPROTOCOLONFCE,
            DSOBSSTATUSNFCE = :DSOBSSTATUSNFCE,
            NRRECIBONFCE = :NRRECIBONFCE,
            CDOPERENVIONFCE = :CDOPERENVIONFCE,
            DTHRPROTOCONFCE = :DTHRPROTOCONFCE,
            IDXMLVALIDNFCE = :IDXMLVALIDNFCE,
            DSQRCODENFCE = :DSQRCODENFCE
        WHERE NRORG = :NRORG
            AND NRSEQVENDA = :NRSEQVENDA
            AND CDFILIAL = :CDFILIAL
            AND CDCAIXA = :CDCAIXA";
            
    const ADQGETDUPLICIDADES = "
        SELECT V.NRACESSONFCE NRCHAVENOTA, V.NRRECIBONFCE NRRECEBIDO, V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, V.CDLOJA, V.DTVENDA, V.CDEMPRESA, V.IDSITUVENDA, V.IDSTATUSNFCE,
              V.IDTPAMBNFCE, V.IDMODOPERACNFCE, V.NRNOTAFISCALCE, V.CDSERIENFCE, V.NRPROTOCOLONFCE, SUBSTR(NRLANCTONFCE,1,2)||SUBSTR(NRACESSONFCE,36,8) AS NRLANCTONFCE,
              SUBSTR(V.DSOBSSTATUSNFCE,1,3) AS CSTAT, V.DSOBSSTATUSNFCE,
              CASE WHEN SUBSTR(V.DSOBSSTATUSNFCE,1,3)='204' THEN V.NRACESSONFCE
                    WHEN SUBSTR(V.NRACESSONFCE,1,2   )='52'  THEN V.NRACESSONFCE
                    WHEN SUBSTR(V.NRACESSONFCE,1,2   )='51' AND SUBSTR(V.DSOBSSTATUSNFCE,1,3)='539' THEN V.NRACESSONFCE
                    ELSE SUBSTR(V.DSOBSSTATUSNFCE, CASE WHEN INSTR(V.DSOBSSTATUSNFCE,'chNFe: ') > 0 THEN INSTR(V.DSOBSSTATUSNFCE,'chNFe: ')+7
                                                        WHEN INSTR(V.DSOBSSTATUSNFCE,'chNFe:' ) > 0 THEN INSTR(V.DSOBSSTATUSNFCE,'chNFe:' )+6
                                                        WHEN INSTR(V.DSOBSSTATUSNFCE,'[ '     ) > 0 THEN INSTR(V.DSOBSSTATUSNFCE,'[ '     )+2
                                                        WHEN INSTR(V.DSOBSSTATUSNFCE,'['      ) > 0 THEN INSTR(V.DSOBSSTATUSNFCE,'['      )+1
                                                  ELSE 0 END, 44) END AS NRACESSONFCE,
              CASE WHEN SUBSTR(V.DSOBSSTATUSNFCE,1,3)='613' THEN V.NRRECIBONFCE
                    ELSE SUBSTR(V.DSOBSSTATUSNFCE, CASE WHEN INSTR(V.DSOBSSTATUSNFCE,'nRec: ' ) > 0 THEN INSTR(V.DSOBSSTATUSNFCE,'nRec: ' )+6
                                                        WHEN INSTR(V.DSOBSSTATUSNFCE,'nRec:'  ) > 0 THEN INSTR(V.DSOBSSTATUSNFCE,'nRec:'  )+5
                                                        WHEN INSTR(V.DSOBSSTATUSNFCE,'[ ',INSTR(V.DSOBSSTATUSNFCE,'[ ')+2) > 0 THEN INSTR(V.DSOBSSTATUSNFCE,'[ ',INSTR(V.DSOBSSTATUSNFCE,'[ ')+2)+2
                                                        ELSE 0 END, 15)
                    END AS NRRECIBONFCE,
              V.DTENVIONFCE, P.NRCERTDIGNFCE, NVL(ARQ.DSARQXMLNFCE, V.DSARQXMLNFCE) AS DSARQXMLNFCE, P.CDVERSAOXMLNFCE
          FROM VENDA V, PARAVEND P, ARQXMLNFCESAT ARQ
         WHERE V.CDFILIAL=P.CDFILIAL AND
            (V.CDFILIAL     = ARQ.CDFILIAL (+)    ) AND
            (V.CDCAIXA      = ARQ.CDCAIXA  (+)   ) AND
            (V.NRSEQVENDA   = ARQ.NRSEQVENDA (+) ) 
          AND V.IDTPEMISVEND='N'
          AND V.IDSTATUSNFCE='R'
          AND (V.DTENTRVENDA BETWEEN TO_DATE(:DATAINI, 'DD/MM/YYYY') AND TO_DATE(:DATAFIN, 'DD/MM/YYYY'))
          AND ((INSTR(:CDFILIAL,V.CDFILIAL)<>0) OR (:CDFILIAL='T'))
          AND (SUBSTR(V.DSOBSSTATUSNFCE,1,3)='204' OR SUBSTR(V.DSOBSSTATUSNFCE,1,3)='539' OR SUBSTR(V.DSOBSSTATUSNFCE,1,3)='613' OR SUBSTR(V.DSOBSSTATUSNFCE, 1, 15) = 'R - Duplicidade' OR V.DSOBSSTATUSNFCE LIKE '%Duplicidade%')
        ORDER BY V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA";
    
    
    const ACMDUPLICIDADES = "
        UPDATE VENDA
          SET IDSTATUSNFCE = 'A',
              NRACESSONFCE = :NRACESSONFCE,
              NRRECIBONFCE = :NRRECIBONFCE,
              DSOBSSTATUSNFCE = :DSOBSSTATUSNFCE
         WHERE CDFILIAL     = :CDFILIAL
          AND CDCAIXA      = :CDCAIXA
          AND NRSEQVENDA   = :NRSEQVENDA"; 
          
    const ACMDUPLICIDADESGOIAS = "
        UPDATE VENDA
         SET IDSTATUSNFCE    = 'A',
             DSOBSSTATUSNFCE = '100 - Autorizado o uso da NFCe',
             NRRECIBONFCE    = NULL,
             NRACESSONFCE    = :NRACESSONFCE
      WHERE CDFILIAL        = :CDFILIAL
         AND CDCAIXA         = :CDCAIXA
         AND NRSEQVENDA      = :NRSEQVENDA";
         
         
    const GETVALIDACHAVEACESSO = "SELECT COUNT(*) as TOT FROM VENDA 
      WHERE NRACESSONFCE = :NRACESSONFCE
      AND NRNOTAFISCALCE = :NRNOTAFISCALCE
      AND CDSERIENFCE = :CDSERIENFCE
      AND NRINSJURIEST = :NRINSJURIEST
      AND TO_CHAR(DTENTRVENDA, 'MM') = :MES
      AND TO_CHAR(DTENTRVENDA, 'YY') = :ANO
      AND (CDFILIAL <> :CDFILIAL OR CDCAIXA <> :CDCAIXA OR NRSEQVENDA <> :NRSEQVENDA )";
      
    const ACMUPDPROTOCNFCECVAC = " 
        UPDATE VENDA
          SET DSOBSSTATUSNFCE = :DSOBSSTATUSNFCE
         WHERE (CDFILIAL   = :CDFILIAL  ) AND
              (CDCAIXA    = :CDCAIXA   ) AND
              (NRSEQVENDA = :NRSEQVENDA)";  
              
    const SELECT_VENDA_ARQXMLNFCESAT_PROT = "
	   SELECT ARQ.CDFILIAL, ARQ.CDCAIXA, ARQ.NRSEQVENDA, ARQ.DSARQXMLNFCE, 
      V.IDTPAMBNFCE, V.NRPROTOCOLONFCE, V.DTHRPROTOCONFCE, 
      V.DSQRCODENFCE, V.IDSTATUSNFCE, V.DSOBSSTATUSNFCE, V.NRACESSONFCE, SUBSTR(V.DSOBSSTATUSNFCE, 0, 3) AS CODSTATUS,
      SUBSTR(V.DSOBSSTATUSNFCE, 7) AS DSOBSSTATUSNFCE2
      FROM ARQXMLNFCESAT ARQ, VENDA V 
      WHERE ARQ.CDFILIAL = V.CDFILIAL
      AND ARQ.CDCAIXA = V.CDCAIXA
      AND ARQ.NRSEQVENDA = V.NRSEQVENDA
      AND V.CDFILIAL = :CDFILIAL
      AND V.CDCAIXA = :CDCAIXA
      AND V.NRSEQVENDA = :NRSEQVENDA";
      
    const SELECT_VENDA_ARQXMLNFCESAT_PROT_CAN = "
	   SELECT ARQ.CDFILIAL, ARQ.CDCAIXA, ARQ.NRSEQVENDA, ARQ.DSARQXMLCANCNFCE, 
      V.IDTPAMBNFCE, V.NRPROTOCOLONFCE, V.DTHRPROTOCOCANC, V.DSRAZAOCANCNFCE, V.NRPROTOCOLOCANC, V.NRINSJURIEST, 
      V.DSQRCODENFCE, V.IDSTATUSNFCE, V.DSOBSSTATUSNFCE, V.NRACESSONFCE, SUBSTR(V.DSOBSSTATUSNFCE, 0, 3) AS CODSTATUS,
      SUBSTR(V.DSOBSSTATUSNFCE, 7) AS DSOBSSTATUSNFCE2, ES.CDESTADOIBGE
      FROM ARQXMLNFCESAT ARQ, VENDA V, ESTADO ES
      WHERE ARQ.CDFILIAL = V.CDFILIAL
      AND ARQ.CDCAIXA = V.CDCAIXA
      AND ARQ.NRSEQVENDA = V.NRSEQVENDA
      AND V.SGESTADO = ES.SGESTADO
      AND V.CDFILIAL = :CDFILIAL
      AND V.CDCAIXA = :CDCAIXA
      AND V.NRSEQVENDA = :NRSEQVENDA";
    
    /* adqItemSemImposto  */  
    const ITENS_SEM_IMPOSTOS = "
      SELECT PR.CDPRODUTO, PR.NMPRODUTO
        FROM VENDA VE, ITEMVENDA IT, PRODUTO PR
      WHERE
         (VE.CDFILIAL      = :CDFILIAL    ) AND
         (VE.CDCAIXA       = :CDCAIXA     ) AND
         (VE.NRSEQVENDA    = :NRSEQVENDA  ) AND
         (VE.CDLOJA        = :CDLOJA      ) AND
         (VE.NRSEQVENDA    = IT.NRSEQVENDA  ) AND
         (VE.CDFILIAL      = IT.CDFILIAL    ) AND
         (VE.CDCAIXA       = IT.CDCAIXA     ) AND
         (IT.CDPRODUTO     = PR.CDPRODUTO   ) AND
         (NOT EXISTS (SELECT 1
                        FROM ALIQIMPFIS AL
                       WHERE AL.CDFILIAL  = VE.CDFILIAL AND
                             AL.CDPRODUTO = IT.CDPRODUTO))
         GROUP BY PR.CDPRODUTO, PR.NMPRODUTO
    ";
    
    const UPDATE_SEM_IMPOSTOS = "
        UPDATE VENDA
         SET DSOBSSTATUSNFCE = :DSOBSSTATUSNFCE
      WHERE CDFILIAL        = :CDFILIAL
         AND CDCAIXA         = :CDCAIXA
         AND NRSEQVENDA      = :NRSEQVENDA";
         
    const ADQNUMERACAOREGCHAVE = "
       SELECT * FROM (SELECT *  FROM ( SELECT V.CDFILIAL, V.CDCAIXA, V.NRNOTAFISCALCE, V.CDSERIENFCE, V.IDTPAMBNFCE,
          V.IDSTATUSNFCE, V.NRSEQVENDA, V.CDFILIAL||'_'||V.CDCAIXA||'_'||V.NRSEQVENDA AS CODNOTA, V.DTENTRVENDA, V.NRACESSONFCE
        FROM
          VENDA V
        WHERE
          (V.CDFILIAL    = :CDFILIAL   ) AND
          ((V.IDSTATUSNFCE IN ('P', 'R') AND (V.IDTPAMBNFCE = '1')) OR (V.IDSTATUSNFCE IN ('P', 'R', 'A', 'C', 'D') AND (V.IDTPAMBNFCE = '2'))) AND
          V.IDTPEMISVEND = 'N'
        ORDER BY
          V.NRNOTAFISCALCE, V.DTENTRVENDA)
      WHERE (CDFILIAL||CDCAIXA||NRSEQVENDA||NRNOTAFISCALCE||CDSERIENFCE||DTENTRVENDA like :ALLFIEDLS  OR :ALLFIEDLS = 'T' ))
      WHERE ROWNUM <= 100";
      
    const ADQDADOSFILIALVENDA = "
      SELECT  V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, V.NRNOTAFISCALCE, V.CDSERIENFCE, PV.IDAMBTRABNFCE, TO_CHAR(V.DTEMISSAONFCE, 'YYYY-MM-DD HH:MM:SS') AS DTEMISSAONFCE, F.NRINSJURFILI, 
      V.NRINSJURIEST, V.NRLANCTONFCE, V.NRACESSONFCE, V.DTENTRVENDA, S.SGESTADO, S.CDESTADOIBGE, V.IDSTATUSNFCE, V.IDTPAMBNFCE
          FROM VENDA V , FILIAL F , PARAVEND PV, ENDEFILI E, ESTADO S
          WHERE (V.CDFILIAL     = PV.CDFILIAL    )
          AND (V.CDFILIAL     = F.CDFILIAL    )
          AND (E.CDFILIAL     = F.CDFILIAL    ) 
          AND (E.IDTPENDEFILI = 'P'           ) 
          AND (S.CDPAIS       = E.CDPAIS      ) 
          AND (S.SGESTADO     = E.SGESTADO    )
          AND V.CDFILIAL = :CDFILIAL 
          AND V.CDCAIXA = :CDCAIXA 
          AND V.NRSEQVENDA = :NRSEQVENDA 
    ";
    
    const UPDATECHAVEACESSO = "
        UPDATE VENDA
          SET IDSTATUSNFCE    = :IDSTATUSNFCE,
              NRINSJURIEST   = :NRINSJURIEST,
              CDSERIENFCE   = :CDSERIENFCE,
              IDTPAMBNFCE   = :IDTPAMBNFCE,
              NRACESSONFCE   = :NRACESSONFCE,
              NRNOTAFISCALCE   = :NRNOTAFISCALCE
         WHERE (CDFILIAL       = :CDFILIAL      ) AND
              (CDCAIXA        = :CDCAIXA       ) AND
              (NRSEQVENDA = :NRSEQVENDA)";   
              
    const SELECTNOVOCODIGO = "SELECT NRSEQUENCIAL FROM NOVOCODIGO WHERE CDCONTADOR = :P_CDCONTADOR";   
    
    const UPDATENOVOCODIGO = "UPDATE NOVOCODIGO
    SET NRSEQUENCIAL = :P_NRSEQUENCIAL
    WHERE CDCONTADOR = :P_CDCONTADOR";
    
    const INSERTNOVOCODIGO = "INSERT INTO NOVOCODIGO ( NRSEQUENCIAL, CDCONTADOR) 
	    VALUES (:P_NRSEQUENCIAL, :P_CDCONTADOR)";
	    
	  const BUSCAR_NOTAS_CORRECAO = "SELECT * 
	   FROM (
          SELECT  SUBSTR('Nota Fiscal: ' || V.NRNOTAFISCALCE || ' Caixa: ' || V.CDCAIXA, 1, 33) AS NOTA,
                  V.DTABERTUR, 
                  V.CDFILIAL, 
                  V.CDCAIXA, 
                  V.CDLOJA, 
                  V.NRSEQVENDA, 
                  V.DTENTRVENDA, 
                  V.NRNOTAFISCALCE, 
                  V.DTEMISSAONFCE, 
                  V.NRRECIBONFCE, 
                  V.NRPROTOCOLONFCE,
                  V.CDSERIENFCE, 
                  V.IDSITUVENDA, 
                  V.IDTPAMBNFCE, 
                  'U' AS IDCHECK, 
                  V.IDSTATUSNFCE, 
                  V.CDEMPRESA, 
                  V.IDMODOPERACNFCE,
                  V.DSOBSSTATUSNFCE, 
                  V.NRACESSONFCE, 
                  V.NRLANCTONFCE, 
                  V.DTHRPROTOCONFCE,
                  V.IDXMLVALIDNFCE, 
                  V.NRINSCRCONS, 
                  V.DSQRCODENFCE, 
                  V.DTVENDA,
                  CASE WHEN V.IDSITUVENDA = 'C' AND V.IDSTATUSNFCE <> 'C' THEN 'S' ELSE 'N' END AS RED,
                  CASE WHEN V.IDSITUVENDA <> 'C' THEN 'S' ELSE 'N' END AS BLACK,
                  V.NRINSJURIEST,
                  SUBSTR(V.DSARQXMLNFCE, (INSTR(V.DSARQXMLNFCE, 'Id=\"NFe')+7), 44) as CHAVEACESSOVENDA,
                  SUBSTR(ARQ.DSARQXMLNFCE, (INSTR(ARQ.DSARQXMLNFCE, 'Id=\"NFe')+7), 44) as CHAVEACESSOXML
                  FROM VENDA V, ARQXMLNFCESAT ARQ
                  WHERE V.CDFILIAL = ARQ.CDFILIAL(+)
                  AND V.CDCAIXA = ARQ.CDCAIXA(+)
                  AND V.NRSEQVENDA = ARQ.NRSEQVENDA(+)
                  AND ((INSTR(:CDFILIAL, V.CDFILIAL) <> 0) OR (:CDFILIAL = 'T'))
                  AND ((INSTR(:CDCAIXA, V.CDFILIAL||'_'||V.CDCAIXA    ) <> 0) OR (:CDCAIXA = 'T'))
                  AND (V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN) 
                  AND ((INSTR(:NRNOTAFISCALCE, V.NRNOTAFISCALCE) <> 0) OR (:NRNOTAFISCALCE = 'T'))
                  AND (V.IDTPAMBNFCE  = :IDTPAMBNFCE)
                  AND V.IDSITUVENDA IN ('O', 'C')
                  AND V.IDTPEMISVEND = 'N'
                  AND V.IDSTATUSNFCE IN ('C', 'P')
          ) B
          WHERE (TO_CHAR(B.NRACESSONFCE) <> TO_CHAR(B.CHAVEACESSOVENDA)) OR B.NRPROTOCOLONFCE IS NULL
          ORDER BY B.DTENTRVENDA";
          
      const GET_DSOBSCUPFIS = "SELECT TRIM(REPLACE(REPLACE(DSOBSCUPFIS,CHR(10),''),CHR(13),'')) AS DSOBSCUPFIS
  FROM CAIXA WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA AND CDLOJA = :CDLOJA";
  
      const VERIFICA_NOTA_DUPLICADA ="SELECT COUNT(NRNOTAFISCALCE) AS TOT FROM VENDA
      WHERE CDSERIENFCE = :CDSERIENFCE AND NRINSJURIEST = :NRINSJURIEST AND NRNOTAFISCALCE = :NRNOTAFISCALCE 
      AND IDTPAMBNFCE = :IDTPAMBNFCE AND IDSTATUSNFCE IN ('A', 'C', 'D')";
  
} 
